const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const policies = sequelize.define(
    'policies',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      scope: {
        type: DataTypes.TEXT,
      },

      rule_logic: {
        type: DataTypes.TEXT,
      },

      effect: {
        type: DataTypes.ENUM,

        values: ['Allow', 'Deny'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  policies.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.policies.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.policies.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.policies.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return policies;
};
